export class OverwolfPlugin {
    #pluginName;
    #plugin = null;
    #promise = null;
    constructor(pluginName) {
        this.#pluginName = pluginName;
    }
    #getPlugin() {
        return new Promise((resolve, reject) => {
            overwolf.extensions.current.getExtraObject(this.#pluginName, result => {
                if (result.success && result.object) {
                    resolve(result.object);
                }
                else {
                    const msg = `Could not load ${this.#pluginName}: ${JSON.stringify(result)}`;
                    console.warn(`OverwolfPlugin.load(): error: ${msg}`);
                    reject(msg);
                }
            });
        });
    }
    async getPlugin() {
        if (this.#plugin) {
            return this.#plugin;
        }
        if (!this.#promise) {
            this.#promise = this.#getPlugin();
        }
        this.#plugin = await this.#promise;
        this.#promise = null;
        return this.#plugin;
    }
}
//# sourceMappingURL=overwolf-plugin.js.map